<template>
  <div class="rui-item" :class="componentCSS">
    <div class="rui-item__header">
      <img v-if="image"
           class="rui-item__header__image"
           :src="image"
           :alt="imageTitle"
           :title="imageTitle">

      <rui-icon v-else-if="icon" class="rui-item__header__icon" :name="icon" />

      <h3 class="rui-item__header__title">{{ caption }}</h3>

      <rui-button v-if="collapsible"
                  class="rui-item__header__icon"
                  text
                  @click="collapsed = !collapsed">
        {{ collapsed ? '▸' : '&blacktriangledown;' }}
      </rui-button>
    </div>
    <div v-if="$slots.aside" class="rui-item__aside">
      <!-- @slot Custom actions and/or context -->
      <slot name="aside" />
    </div>
    <div v-if="$slots.default" class="rui-item__content">
      <slot />
    </div>
  </div>
</template>

<script>
import RuiIcon from '../Icon/Icon.vue'
import RuiButton from '../Button/Button.vue'

/**
 * Component to display a big "item" in a list
 *
 * @preset Default {
 *                   "props": { "caption": "My first thing" },
 *                   "slots": { "default": "Here, some content", "aside": "actions, context,..." }
 *                 }
 * @propsGroup Display  [disabled]
 * @propsGroup Behavior [collapsible]
 * @propsGroup Content  [caption, icon, image, imageTitle]
 */
export default {
  name: 'RuiItem',
  components: { RuiButton, RuiIcon },
  props: {
    /** Header text */
    caption: { required: true, type: String, default: null },
    /** Optional icon name. May be overridden by `image` prop */
    icon: { required: false, type: String, default: null },
    /** Optional image URL. Overrides `icon` prop */
    image: { required: false, type: String, default: null },
    /** Additional image title (and alt) attribute */
    imageTitle: { required: false, type: String, default: null },
    /** Whether the content can be collapsed */
    collapsible: { required: false, type: Boolean, default: false },
    /** Whether the item is considered disabled */
    disabled: { required: false, type: Boolean, default: false },
  },
  data () {
    return {
      collapsed: this.collapsible && this.disabled,
    }
  },
  computed: {
    componentCSS () {
      return [
        this.collapsible && this.collapsed && 'rui-item--collapsed',
        this.disabled && 'rui-item--disabled',
      ]
    },
  },
}
</script>
